/**
 * 
 */
package net.gorry.aicia;

import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceActivity;
import android.preference.PreferenceManager;
import android.util.Log;
import android.view.KeyEvent;

/**
 * 
 * アプリケーション一覧の編集
 * 
 * @author GORRY
 *
 */
public class ActivityExAppList extends PreferenceActivity  {
	private static final String TAG = "ActivitySystemConfig";
	private static final boolean V = false;
	private Activity me;
	private boolean noFinishIt = false;


	/* アプリの一時退避
	 * onRestoreInstanceState()は来ないので注意
	 * @see android.app.Activity#onSaveInstanceState(android.os.Bundle)
	 */
	@Override
	protected void onSaveInstanceState(final Bundle outState) {
		if (V) Log.v(TAG, "onSaveInstanceState()");
		noFinishIt = true;
	}

	/**
	 * 作成
	 * @see android.preference.PreferenceActivity#onCreate(android.os.Bundle)
	 */
	@Override
	protected void onCreate(final Bundle savedInstanceState) {
		if (V) Log.v(TAG, "onCreate()");
		super.onCreate(savedInstanceState);
		me = this;

		final SharedPreferences sp = PreferenceManager.getDefaultSharedPreferences(me);
		SystemConfig.loadConfig();
		SystemConfig.clearForPreferenceActivity(sp);
		SystemConfig.setForPreferenceActivity(sp);

		final int pref = R.xml.pref_exapplist;
		addPreferencesFromResource(pref);

		/*
		Preference p;
		p = findPreference("pref_exapplist_app0");
		p.setOnPreferenceClickListener(new preferenceClickListener());
		pref_exapplist_app0 = p;

		p = findPreference("pref_exapplist_app1");
		p.setOnPreferenceClickListener(new preferenceClickListener());
		pref_exapplist_app1 = p;

		p = findPreference("pref_exapplist_app2");
		p.setOnPreferenceClickListener(new preferenceClickListener());
		pref_exapplist_app2 = p;

		p = findPreference("pref_exapplist_app3");
		p.setOnPreferenceClickListener(new preferenceClickListener());
		pref_exapplist_app3 = p;
		 */
	}

	/*
	private Preference pref_exapplist_app0;
	private Preference pref_exapplist_app1;
	private Preference pref_exapplist_app2;
	private Preference pref_exapplist_app3;
	private int pref_exapplist_id;
	private class preferenceClickListener implements OnPreferenceClickListener {
		public boolean onPreferenceClick(final Preference pref) {
			int id = -1;
			if (pref == pref_exapplist_app0) {
				id = 0;
			} else if (pref == pref_exapplist_app1) {
				id = 1;
			} else if (pref == pref_exapplist_app2) {
				id = 2;
			} else if (pref == pref_exapplist_app3) {
				id = 3;
			}
			if (id >= 0) {
				pref_exapplist_id = id;
				final Intent intent = new Intent(me, AppListDialogPreference.class);
				intent.putExtra("appname", SystemConfig.exAppName[id]);
				intent.putExtra("packagename", SystemConfig.exAppPackageName[id]);
				startActivityForResult(intent, 0);
			}
			return true;
		}
	}
	 */

	/*
	@Override
	protected void onActivityResult(final int requestCode, final int resultCode, final Intent intent) {
		super.onActivityResult(requestCode, resultCode, intent);

		if (requestCode == 0){
			if (resultCode == RESULT_OK){
				final Bundle extras = intent.getExtras();
				if (extras != null){
					final int id = pref_exapplist_id;
					SystemConfig.exAppName[id] = extras.getString("appname");
					SystemConfig.exAppPackageName[id] = extras.getString("packagename");
				}
			}
		}
	}
	 */

	/*
	 * 再起動
	 * @see android.app.Activity#onRestart()
	 */
	@Override
	public void onRestart() {
		if (V) Log.v(TAG, "onRestart()");
		super.onRestart();
	}

	/*
	 * 開始
	 * @see android.app.Activity#onStart()
	 */
	@Override
	public void onStart() {
		if (V) Log.v(TAG, "onStart()");
		super.onStart();
	}

	/*
	 * 再開
	 * @see android.app.Activity#onResume()
	 */
	@Override
	public synchronized void onResume() {
		if (V) Log.v(TAG, "onResume()");
		super.onResume();
		if (!noFinishIt) {
			//
		}
		noFinishIt = false;
	}

	/*
	 * 停止
	 * @see android.app.Activity#onPause()
	 */
	@Override
	public synchronized void onPause() {
		if (V) Log.v(TAG, "onPause()");
		super.onPause();
		if (!noFinishIt) {
			//
		}
	}

	/*
	 * 中止
	 * @see android.app.Activity#onStop()
	 */
	@Override
	public void onStop() {
		if (V) Log.v(TAG, "onStop()");
		super.onStop();
	}

	//
	/*
	 * 破棄
	 * @see android.preference.PreferenceActivity#onDestroy()
	 */
	@Override
	public void onDestroy() {
		if (V) Log.v(TAG, "onDestroy()");
		super.onDestroy();
	}

	/*
	 * コンフィギュレーション変更
	 * @see android.app.Activity#onConfigurationChanged(android.content.res.Configuration)
	 */
	/*
	@Override
	public void onConfigurationChanged(final Configuration newConfig) {
		if (V) Log.v(TAG, "onConfigurationChanged()");
		super.onConfigurationChanged(newConfig);
	}
	 */

	/*
	 * キー入力
	 * @see android.app.Activity#onKeyDown(int, android.view.KeyEvent)
	 */
	@Override
	public boolean onKeyDown(final int keyCode, final KeyEvent event) {
		if (V) Log.v(TAG, "onConfigurationChanged()");
		if (keyCode == KeyEvent.KEYCODE_BACK) {
			// アクティビティ終了として使う
			final SharedPreferences sp = PreferenceManager.getDefaultSharedPreferences(me);
			final int rebootLevel = SystemConfig.getFromPreferenceActivity(sp);
			SystemConfig.saveConfig();
			SystemConfig.clearForPreferenceActivity(sp);
			final Intent intent = new Intent();
			intent.putExtra("rebootlevel", rebootLevel);
			setResult(RESULT_OK, intent);
			finish();
			return true;
		}
		super.onKeyDown(keyCode, event);
		return false;
	}



}
