/**
 * 
 */
package net.gorry.aicia;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.content.pm.ResolveInfo;
import android.graphics.Bitmap;
import android.graphics.Matrix;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.os.Handler;
import android.preference.DialogPreference;
import android.util.AttributeSet;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;

/**
 * 
 * アプリ一覧から選択
 * 
 * @author GORRY
 *
 */
public class AppListDialogPreference extends DialogPreference  {
	private static final String TAG = "AppListDialogPreference";
	private static final boolean V = false;
	private static final int WC = ViewGroup.LayoutParams.WRAP_CONTENT;
	private static final int FP = ViewGroup.LayoutParams.FILL_PARENT;
	private final Context me;

	private String mAppName;
	private String mPackageName;
	private String mActivityName;

	private LinearLayout mBaseLayout;
	private LinearLayout mRow1Layout;
	private LinearLayout mRow2Layout;
	private TableLayout mTableLayout;
	private TableRow mTableRowAppName;
	private TableRow mTableRowPackageName;
	private TableRow mTableRowButtons;
	private TextView mTextAppName;
	private TextView mTextActivityName;
	private TextView mTextDummy;
	private ImageView mImageIcon;
	private EditText mEditAppName;
	private EditText mEditActivityName;
	private Button mButtonChoose;
	private int mId;

	/**
	 * @param context context
	 * @param attrs attrs
	 */
	public AppListDialogPreference(final Context context, final AttributeSet attrs) {
		super(context, attrs);
		me = context;
	}

	/**
	 * @param context context
	 * @param attrs attrs
	 * @param defStyle defStyle
	 */
	public AppListDialogPreference(final Context context, final AttributeSet attrs, final int defStyle) {
		super(context, attrs, defStyle);
		me = context;
	}

	@Override
	protected View onCreateDialogView() {
		if (V) Log.v(TAG, "onCreateDialogView()");
		final String key = getKey();
		mId = 0;

		if (key.equals(me.getText(R.string.pref_exapplist_app0))) {
			mId = 0;
		} else if (key.equals(me.getText(R.string.pref_exapplist_app1))) {
			mId = 1;
		} else if (key.equals(me.getText(R.string.pref_exapplist_app2))) {
			mId = 2;
		} else if (key.equals(me.getText(R.string.pref_exapplist_app3))) {
			mId = 3;
		}

		mAppName = SystemConfig.exAppName[mId];
		mActivityName = SystemConfig.exAppPackageName[mId];

		mBaseLayout = new LinearLayout(me) /*{
			private boolean onFirst = true;
			@Override
			protected void onSizeChanged(final int w, final int h, final int oldw, final int oldh) {
				if (onFirst) {
					onFirst = false;
					mTableLayout.setGravity(Gravity.CENTER);
					// mTableRowAppName.updateViewLayout(mEditAppName, new TableLayout.LayoutParams(FP, WC));
					mBaseLayout.updateViewLayout(mTableLayout, new TableLayout.LayoutParams(FP, WC));
					// mTableLayout.updateViewLayout(mTableRowAppName, new TableLayout.LayoutParams(FP, WC));
				}
			}
		}*/;
		// mBaseLayout.setLayoutParams(new LinearLayout.LayoutParams(FP, WC));
		mBaseLayout.setOrientation(LinearLayout.VERTICAL);

		/*
		mTableLayout = new TableLayout(me);
		// mTableLayout.setLayoutParams(new TableLayout.LayoutParams(WC, WC));
		mBaseLayout.addView(mTableLayout);
		{
			mTableRowAppName = new TableRow(me);
			// mTableRowAppName.setLayoutParams(new TableLayout.LayoutParams(WC, WC));
			mTableLayout.addView(mTableRowAppName);
			{
				mTextAppName = new TextView(me);
				mTextAppName.setText("Title:");
				mTableRowAppName.addView(mTextAppName);

				mEditAppName = new EditText(me);
				// mEditAppName.setLayoutParams(new TableLayout.LayoutParams(100, WC));
				mEditAppName.setText(mAppName);
				mEditAppName.setSingleLine(true);
				mTableRowAppName.addView(mEditAppName);
			}
		}

		{
			mTableRowPackageName = new TableRow(me);
			// mTableRowPackageName.setLayoutParams(new TableLayout.LayoutParams(WC, WC));
			mTableLayout.addView(mTableRowPackageName);
			{
				mImageIcon = new ImageView(me);
				mTableRowPackageName.addView(mImageIcon);

				mEditPackageName = new EditText(me);
				// mEditPackageName.setLayoutParams(new TableLayout.LayoutParams(100, WC));
				mEditPackageName.setText(mPackageName);
				mEditPackageName.setSingleLine(true);
				mEditPackageName.setEnabled(false);
				mTableRowPackageName.addView(mEditPackageName);
			}
		}

		{
			mTableRowButtons = new TableRow(me);
			mTableRowButtons.setLayoutParams(new TableLayout.LayoutParams(WC, WC));
			mTableLayout.addView(mTableRowButtons);
			{
				mTextDummy = new TextView(me);
				mTextDummy.setText("");
				mTableRowButtons.addView(mTextDummy);

				mButtonChoose = new Button(me);
				// mButtonChoose.setLayoutParams(new TableLayout.LayoutParams(100, WC));
				mButtonChoose.setText("Choose");
				mButtonChoose.setWidth(200);
				mButtonChoose.setOnClickListener(onClickButtonChoose);
				mTableRowButtons.addView(mButtonChoose);
			}
		}
		 */

		mRow1Layout = new LinearLayout(me);
		mRow1Layout.setOrientation(LinearLayout.HORIZONTAL);
		mRow2Layout = new LinearLayout(me);
		mRow2Layout.setOrientation(LinearLayout.HORIZONTAL);
		mBaseLayout.addView(mRow1Layout);
		mBaseLayout.addView(mRow2Layout);

		mTextAppName = new TextView(me);
		mTextAppName.setText("Title:");
		mRow1Layout.addView(mTextAppName);

		mEditAppName = new EditText(me);
		mEditAppName.setText(mAppName);
		mEditAppName.setSingleLine(true);
		mEditAppName.setLayoutParams(new TableLayout.LayoutParams(FP, WC));
		mRow1Layout.addView(mEditAppName);

		final DisplayMetrics metrics = new DisplayMetrics();
		((Activity)me).getWindowManager().getDefaultDisplay().getMetrics(metrics);
		mImageIcon = new ImageView(me);
		mImageIcon.setLayoutParams(new LinearLayout.LayoutParams((int)(48*metrics.scaledDensity), (int)(48*metrics.scaledDensity)));
		setIcon(mImageIcon);
		mRow2Layout.addView(mImageIcon);

		mTextActivityName = new TextView(me);
		mTextActivityName.setText(mActivityName);
		mTextActivityName.setGravity(Gravity.CENTER_VERTICAL);
		mRow2Layout.addView(mTextActivityName);

		mButtonChoose = new Button(me);
		mButtonChoose.setText("Choose");
		mButtonChoose.setOnClickListener(onClickButtonChoose);
		mBaseLayout.addView(mButtonChoose);

		return mBaseLayout;
	}

	@Override
	protected void onDialogClosed(final boolean positiveResult) {
		if (V) Log.v(TAG, "onDialogClosed()");
		if (positiveResult) {
			mAppName = mEditAppName.getText().toString();
			mActivityName = mEditActivityName.getText().toString();
			SystemConfig.exAppName[mId] = mAppName;
			SystemConfig.exAppPackageName[mId] = mActivityName;
		}
		super.onDialogClosed(positiveResult);
	}

	private final OnClickListener onClickButtonChoose = new OnClickListener()
	{
		final ArrayList<ResolveInfo> appList = new ArrayList<ResolveInfo>();

		public void createApplicationMenu()
		{
			final AwaitAlertDialogIconList dlg = new AwaitAlertDialogIconList(me);
			final ProgressDialog pd = new ProgressDialog(me);
			final Handler h = new Handler();

			final Runnable openMenu = new Runnable() {
				public void run() {
					dlg.setTitle(me.getString(R.string.activitymain_java_exapp_title));
					dlg.setLongClickEnable(false);
					dlg.create();

					new Thread(new Runnable() {	public void run() {
						final int result = dlg.show();
						if (result != AwaitAlertDialogBase.CANCEL) {
							final int id = result - AwaitAlertDialogList.CLICKED;
							if ((0 <= id) && (id < appList.size())) {
								((Activity)me).runOnUiThread(new Runnable(){ public void run() {
									final PackageManager pm = me.getPackageManager();
									final ResolveInfo info = appList.get(id);
									mAppName = info.activityInfo.loadLabel(pm).toString();
									mEditAppName.setText(mAppName);
									mPackageName = info.activityInfo.applicationInfo.packageName;
									mActivityName = info.activityInfo.name;
									mTextActivityName.setText(mActivityName);
									setIcon(mImageIcon);
								}});
							}
						}
					} }).start();
				}
			};

			final Runnable dismissProgressDialog = new Runnable() {
				public void run() {
					pd.dismiss();
					h.post(openMenu);
				}
			};

			final Runnable createMenu = new Runnable() {
				public void run() {
					new Thread(new Runnable() {	public void run() {
						final PackageManager pm = me.getPackageManager();
						final Intent intent = new Intent(Intent.ACTION_MAIN, null);
						intent.addCategory(Intent.CATEGORY_LAUNCHER);
						final List<ResolveInfo> apps = pm.queryIntentActivities(intent, 0);
						Collections.sort(apps, new ResolveInfo.DisplayNameComparator(pm));

						for (int i=0; i<apps.size(); i++) {
							final ResolveInfo info = apps.get(i);
							appList.add(info);
							final String label = info.activityInfo.loadLabel(pm).toString();
							final Drawable icon = info.activityInfo.loadIcon(pm);
							dlg.addItem(label, icon, 1);
						}

						h.post(dismissProgressDialog);
					} }).start();
				}
			};

			final Runnable showProgressDialog = new Runnable() {
				public void run() {
					pd.setTitle(me.getString(R.string.activitymain_java_progress_createapplicationmenu));
					pd.setIndeterminate(true);
					pd.setCancelable(false);
					pd.show();
					h.post(createMenu);
				}
			};

			h.post(showProgressDialog);
		}

		public void onClick(final View v)
		{
			if (V) Log.v(TAG, "onClick() onClickButtonPackageName");

			((Activity)me).runOnUiThread(new Runnable(){ public void run() {
				createApplicationMenu();
			}});
		}
	};

	/**
	 * アイコンのリサイズ
	 * @param icon アイコン
	 * @return リサイズ後アイコン
	 */
	public Drawable resizeIcon(final Drawable icon) {
		if (V) Log.v(TAG, "resizeIcon()");
		if (icon != null) {
			final DisplayMetrics metrics = new DisplayMetrics();
			((Activity)me).getWindowManager().getDefaultDisplay().getMetrics(metrics);
			final float dw = 48*metrics.scaledDensity;
			final float dh = 48*metrics.scaledDensity;
			final Bitmap bmp = ((BitmapDrawable)icon).getBitmap();
			if (bmp != null) {
				final int sw = bmp.getWidth();
				final int sh = bmp.getHeight();
				if (V) Log.v(TAG, "sw="+sw+" sh="+sh);
				if ((sw == (int)dw) && (sh == (int)dh)) {
					return icon;
				}
				final Matrix m = new Matrix();
				m.postScale(dw/sw, dh/sh);
				final Bitmap bmp2 = Bitmap.createBitmap(bmp, 0, 0, sw, sh, m, true);
				final Drawable icon2 = new BitmapDrawable(bmp2);
				return icon2;
			}
			return icon;
		}
		return null;
	}

	/**
	 * アイコンを取得
	 * @param packageName パッケージ名
	 * @param activityName アクティビティ名
	 * @return アイコン
	 */
	public Drawable getIcon(final String packageName, final String activityName) {
		ResolveInfo info = null;
		final PackageManager pm = me.getPackageManager();
		final Intent intent = new Intent();
		List<ResolveInfo> apps = null;
		try {
			intent.setClassName(packageName, activityName);
			apps = pm.queryIntentActivities(intent, 0);
		} catch (final Exception e) {
			// e.printStackTrace();
		}
		if (apps != null) {
			if (apps.size() > 0) {
				info = apps.get(0);
				if (info != null) {
					final Drawable icon = info.activityInfo.loadIcon(pm);
					return resizeIcon(icon);
				}
			}
		}
		return (null);
	}

	/**
	 * アイコンをビューに表示
	 * @param v ビュー
	 */
	public void setIcon(final ImageView v) {
		final Drawable icon = getIcon(mPackageName, mActivityName);
		if (icon != null) {
			v.setImageDrawable(icon);
		}
	}

}
