/**
 * 
 * AiCiA - Android IRC Client
 * 
 * Copyright (C)2010 GORRY.
 * 
 */

package net.gorry.aicia;

import android.content.Context;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.graphics.Color;
import android.util.Log;

/**
 * 
 * システム設定
 * 
 * @author GORRY
 *
 */
public class SystemConfig {
	private static final String TAG = "Systepref"; //$NON-NLS-1$
	private static final boolean V = false;

	private static Context me = null;
	private static boolean isLandscape = false;

	/** */
	public static int verbose;

	/** */
	public static int rotateMode;

	/** */
	public static int dateMode;

	/** */
	public static int channelLogBufferSize;
	/** */
	public static int otherChannelLogBufferSize;
	/** */
	public static int spanChannelLogLines;
	/** */
	public static int spanOtherChannelLogLines;

	/** */
	public static int mainLogBufferSize;
	/** */
	public static int subLogBufferSize;
	/** */
	public static int cmdLineTextSize;

	/** */
	public static final int maxColorSet = 4;
	/** */
	public static int nowColorSet = 0;
	/** */
	public static int[] mainLogBackgroundColor = new int[maxColorSet];
	/** */
	public static int[] mainLogDateColor = new int[maxColorSet];
	/** */
	public static int[] mainLogTextColor = new int[maxColorSet];
	/** */
	public static int[] mainLogPaleTextColor = new int[maxColorSet];
	/** */
	public static int[] subLogBackgroundColor = new int[maxColorSet];
	/** */
	public static int[] subLogDateColor = new int[maxColorSet];
	/** */
	public static int[] subLogTextColor = new int[maxColorSet];
	/** */
	public static int[] subLogPaleTextColor = new int[maxColorSet];
	/** */
	public static int[] alertKeywordsColor = new int[maxColorSet];

	/** */
	public static boolean ringOnAlert;
	/** */
	public static boolean vibrateOnAlert;

	/** */
	public static int autoReconnectWaitSec;
	/** */
	public static int checkConnectWaitSec;

	/** */
	public static boolean now_horizontalMode;
	/** */
	public static int now_subWindowMode;
	/** */
	public static int now_mainLogFontSize;
	/** */
	public static int now_subLogFontSize;
	/** */
	public static int now_editFontSize;

	/** */
	public static boolean portrait_horizontalMode;
	/** */
	public static int portrait_subWindowMode;
	/** */
	public static int portrait_mainLogFontSize;
	/** */
	public static int portrait_subLogFontSize;
	/** */
	public static int portrait_editFontSize;

	/** */
	public static boolean landscape_horizontalMode;
	/** */
	public static int landscape_subWindowMode;
	/** */
	public static int landscape_mainLogFontSize;
	/** */
	public static int landscape_subLogFontSize;
	/** */
	public static int landscape_editFontSize;

	/** */
	public static String TIG_oldRTCmd;
	/** */
	public static Boolean twitterSiteIsMobile;

	/** */
	public static Boolean allowSendHalfKana;

	/** */
	public static final int maxExApp = 4;
	/** */
	public static String[] exAppName = new String[maxExApp];
	/** */
	public static String[] exAppPackageName = new String[maxExApp];

	/** */
	public static final int maxExWebSite = 4;
	/** */
	public static String[] exWebSiteName = new String[maxExWebSite];
	/** */
	public static String[] exWebSiteUrl = new String[maxExWebSite];

	/**
	 * カラーセットの初期化
	 * @param index index
	 */
	public static void initializeColorSet(final int index) {
		switch (index) {
		case 0:
		case 2:
			mainLogBackgroundColor[index] = Color.BLACK;
			mainLogDateColor[index]       = Color.GREEN;
			mainLogTextColor[index]       = Color.WHITE;
			mainLogPaleTextColor[index]   = Color.GRAY;
			subLogBackgroundColor[index]  = Color.rgb(32,32,32);
			subLogDateColor[index]        = Color.GREEN;
			subLogTextColor[index]        = Color.WHITE;
			subLogPaleTextColor[index]    = Color.GRAY;
			alertKeywordsColor[index]     = Color.RED;
			break;
		case 1:
		case 3:
			mainLogBackgroundColor[index] = Color.WHITE;
			mainLogDateColor[index]       = Color.rgb(0,128,0);
			mainLogTextColor[index]       = Color.BLACK;
			mainLogPaleTextColor[index]   = Color.GRAY;
			subLogBackgroundColor[index]  = Color.rgb(224,224,224);
			subLogDateColor[index]        = Color.rgb(0,128,0);
			subLogTextColor[index]        = Color.BLACK;
			subLogPaleTextColor[index]    = Color.GRAY;
			alertKeywordsColor[index]     = Color.RED;
		}
	}

	/**
	 * 設定消去
	 */
	public static void deleteConfig() {
		if (V) Log.v(TAG, "deleteConfig()");

		final SharedPreferences pref = me.getSharedPreferences("system", 0);
		final SharedPreferences.Editor editor = pref.edit();

		editor.remove("verbose");

		editor.remove("rotatemode");

		editor.remove("datemode");

		editor.remove("channellogbuffersize");
		editor.remove("otherchannellogbuffersize");
		editor.remove("spanchannelloglines");
		editor.remove("spanotherchannelloglines");

		editor.remove("mainlogbuffersize");
		editor.remove("sublogbuffersize");
		editor.remove("cmdlinetextsize");

		editor.remove("nowcolorset");
		editor.remove("mainlogbackgroundcolor");
		editor.remove("mainlogdatecolor");
		editor.remove("mainlogtextcolor");
		editor.remove("sublogbackgroundcolor");
		editor.remove("sublogdatecolor");
		editor.remove("sublogtextcolor");
		editor.remove("alertkeywordscolor");
		editor.remove("logcolor");
		editor.remove("palelogcolor");
		for (int i=0; i<maxColorSet; i++) {
			editor.remove("nowcolorset"+i);
			editor.remove("mainlogbackgroundcolor"+i);
			editor.remove("mainlogdatecolor"+i);
			editor.remove("mainlogtextcolor"+i);
			editor.remove("sublogbackgroundcolor"+i);
			editor.remove("sublogdatecolor"+i);
			editor.remove("sublogtextcolor"+i);
			editor.remove("alertkeywordscolor"+i);
			editor.remove("logcolor"+i);
			editor.remove("palelogcolor"+i);
		}

		editor.remove("ringonalert");
		editor.remove("vibrateonalert");

		editor.remove("autoreconnectwaitsec");
		editor.remove("checkconnectwaitsec");

		editor.remove("portrait_horizontalmode");
		editor.remove("portrait_subwindowmode");
		editor.remove("portrait_mainlogfontsize");
		editor.remove("portrait_sublogfontsize");
		editor.remove("portrait_editfontsize");

		editor.remove("landscape_horizontalmode");
		editor.remove("landscape_subwindowmode");
		editor.remove("landscape_mainlogfontsize");
		editor.remove("landscape_sublogfontsize");
		editor.remove("landscape_editfontsize");

		editor.remove("tig_oldrtcmd");
		editor.remove("twittersiteismobile");

		editor.remove("allowsendhalfkana");

		for (int i=0; i<maxExApp; i++) {
			editor.remove("exAppName"+i);
			editor.remove("exAppPackageName"+i);
		}

		for (int i=0; i<maxExWebSite; i++) {
			editor.remove("ExWebSiteName"+i);
			editor.remove("ExWebSiteUrl"+i);
		}

		editor.commit();
	}

	/**
	 * 設定読み込み
	 */
	public static void loadConfig() {
		if (V) Log.v(TAG, "loadConfig()");

		final SharedPreferences pref = me.getSharedPreferences("system", 0);

		verbose = pref.getInt("verbose", 0);

		rotateMode = pref.getInt("rotatemode", 0);

		dateMode = pref.getInt("datemode", 1);

		channelLogBufferSize = pref.getInt("channellogbuffersize", 1024*8);
		otherChannelLogBufferSize = pref.getInt("otherchannellogbuffersize", 1024*8);
		spanChannelLogLines = pref.getInt("spanchannelloglines", 200);
		spanOtherChannelLogLines = pref.getInt("spanotherchannelloglines", 200);

		mainLogBufferSize = pref.getInt("mainlogbuffersize", 1024*16);
		subLogBufferSize = pref.getInt("sublogbuffersize", 1024*16);
		cmdLineTextSize = pref.getInt("cmdlinetextsize", 0);

		initializeColorSet(0);
		initializeColorSet(1);
		initializeColorSet(2);
		initializeColorSet(3);
		nowColorSet = pref.getInt("nowcolorset", 0);
		for (int i=0; i<maxColorSet; i++) {
			mainLogBackgroundColor[i] = pref.getInt("mainlogbackgroundcolor"+i, mainLogBackgroundColor[i]);
			mainLogDateColor[i] = pref.getInt("mainlogdatecolor"+i, mainLogDateColor[i]);
			mainLogTextColor[i] = pref.getInt("mainlogtextcolor"+i, mainLogTextColor[i]);
			mainLogPaleTextColor[i] = pref.getInt("mainlogpaletextcolor"+i, mainLogPaleTextColor[i]);
			subLogBackgroundColor[i] = pref.getInt("sublogbackgroundcolor"+i, subLogBackgroundColor[i]);
			subLogDateColor[i] = pref.getInt("sublogdatecolor"+i, subLogDateColor[i]);
			subLogTextColor[i] = pref.getInt("sublogtextcolor"+i, subLogTextColor[i]);
			subLogPaleTextColor[i] = pref.getInt("sublogpaletextcolor"+i, subLogPaleTextColor[i]);
			alertKeywordsColor[i] = pref.getInt("alertkeywordscolor"+i, alertKeywordsColor[i]);
		}

		ringOnAlert = pref.getBoolean("ringonalert", true);
		vibrateOnAlert = pref.getBoolean("vibrateonalert", true);

		autoReconnectWaitSec = pref.getInt("autoreconnectwaitsec", 30);
		checkConnectWaitSec = pref.getInt("checkconnectwaitsec", 90);

		portrait_horizontalMode = pref.getBoolean("portrait_horizontalmode", false);
		portrait_subWindowMode = pref.getInt("portrait_subwindowmode", 2);
		portrait_mainLogFontSize = pref.getInt("portrait_mainlogfontsize", 10);
		portrait_subLogFontSize = pref.getInt("portrait_sublogfontsize", 10);
		portrait_editFontSize = pref.getInt("portrait_editfontsize", 12);

		landscape_horizontalMode = pref.getBoolean("landscape_horizontalmode", true);
		landscape_subWindowMode = pref.getInt("landscape_subwindowmode", 2);
		landscape_mainLogFontSize = pref.getInt("landscape_mainlogfontsize", 10);
		landscape_subLogFontSize = pref.getInt("landscape_sublogfontsize", 10);
		landscape_editFontSize = pref.getInt("landscape_editfontsize", 12);

		TIG_oldRTCmd = pref.getString("tig_oldrtcmd", "mrt");
		twitterSiteIsMobile = pref.getBoolean("twittersiteismobile", true);

		allowSendHalfKana = pref.getBoolean("allowsendhalfkana", false);

		for (int i=0; i<maxExApp; i++) {
			exAppName[i] = pref.getString("exapp_name"+i, "");
			exAppPackageName[i] = pref.getString("exapp_packagename"+i, "");
			exAppName[i] = "exapp_name"+i;
			exAppPackageName[i] = "exapp_packagename"+i;
		}

		for (int i=0; i<maxExWebSite; i++) {
			exWebSiteName[i] = pref.getString("exwebsite_name"+i, "Name"+i);
			exWebSiteUrl[i] = pref.getString("exwebsite_url"+i, "Url"+i);
			exWebSiteName[i] = "exwebsite_name"+i;
			exWebSiteUrl[i] = "exwebsite_url"+i;
		}

		setOrientation(isLandscape);

	}

	/**
	 * 設定保存
	 */
	public static void saveConfig() {
		if (V) Log.v(TAG, "saveConfig()");

		final SharedPreferences pref = me.getSharedPreferences("system", 0);
		final SharedPreferences.Editor editor = pref.edit();

		editor.putInt("verbose", verbose);

		editor.putInt("rotatemode", rotateMode);

		editor.putInt("datemode", dateMode);

		editor.putInt("channellogbuffersize", channelLogBufferSize);
		editor.putInt("otherchannellogbuffersize", otherChannelLogBufferSize);
		editor.putInt("spanchannelloglines", spanChannelLogLines);
		editor.putInt("spanotherchannelloglines", spanOtherChannelLogLines);

		editor.putInt("mainlogbuffersize", mainLogBufferSize);
		editor.putInt("sublogbuffersize", subLogBufferSize);
		editor.putInt("cmdlinetextsize", cmdLineTextSize);

		editor.putInt("nowcolorset", nowColorSet);
		for (int i=0; i<maxColorSet; i++) {
			editor.putInt("mainlogbackgroundcolor"+i, mainLogBackgroundColor[i]);
			editor.putInt("mainlogdatecolor"+i, mainLogDateColor[i]);
			editor.putInt("mainlogtextcolor"+i, mainLogTextColor[i]);
			editor.putInt("mainlogpaletextcolor"+i, mainLogPaleTextColor[i]);
			editor.putInt("sublogbackgroundcolor"+i, subLogBackgroundColor[i]);
			editor.putInt("sublogdatecolor"+i, subLogDateColor[i]);
			editor.putInt("sublogtextcolor"+i, subLogTextColor[i]);
			editor.putInt("sublogpaletextcolor"+i, subLogPaleTextColor[i]);
			editor.putInt("alertkeywordscolor"+i, alertKeywordsColor[i]);
		}

		editor.putBoolean("ringonalert", ringOnAlert);
		editor.putBoolean("vibrateonalert", vibrateOnAlert);

		editor.putInt("autoreconnectwaitsec", autoReconnectWaitSec);
		editor.putInt("checkconnectwaitsec", checkConnectWaitSec);

		editor.putBoolean("portrait_horizontalmode", portrait_horizontalMode);
		editor.putInt("portrait_subwindowmode", portrait_subWindowMode);
		editor.putInt("portrait_mainlogfontsize", portrait_mainLogFontSize);
		editor.putInt("portrait_sublogfontsize", portrait_subLogFontSize);
		editor.putInt("portrait_editfontsize", portrait_editFontSize);

		editor.putBoolean("landscape_horizontalmode", landscape_horizontalMode);
		editor.putInt("landscape_subwindowmode", landscape_subWindowMode);
		editor.putInt("landscape_mainlogfontsize", landscape_mainLogFontSize);
		editor.putInt("landscape_sublogfontsize", landscape_subLogFontSize);
		editor.putInt("landscape_editfontsize", landscape_editFontSize);

		editor.putString("tig_oldrtcmd", TIG_oldRTCmd);
		editor.putBoolean("twittersiteismobile", twitterSiteIsMobile);

		editor.putBoolean("allowsendhalfkana", allowSendHalfKana);

		for (int i=0; i<maxExApp; i++) {
			editor.putString("exapp_name"+i, exAppName[i]);
			editor.putString("exapp_packagename"+i, exAppPackageName[i]);
		}

		for (int i=0; i<maxExWebSite; i++) {
			editor.putString("exwebsite_name"+i, exWebSiteName[i]);
			editor.putString("exwebsite_url"+i, exWebSiteUrl[i]);
		}

		editor.commit();
	}

	/**
	 * コンテキスト設定
	 * @param context コンテキスト
	 */
	public static void setContext(final Context context) {
		if (me == null) {
			me = context;
		}
	}

	/**
	 * 回転方向設定
	 * @param orientation 横長ならtrue
	 */
	public static void setOrientation(final boolean orientation) {
		isLandscape = orientation;
		if (isLandscape) {
			now_horizontalMode = landscape_horizontalMode;
			now_subWindowMode = landscape_subWindowMode;
			now_mainLogFontSize = landscape_mainLogFontSize;
			now_subLogFontSize = landscape_subLogFontSize;
			now_editFontSize = landscape_editFontSize;
		} else {
			now_horizontalMode = portrait_horizontalMode;
			now_subWindowMode = portrait_subWindowMode;
			now_mainLogFontSize = portrait_mainLogFontSize;
			now_subLogFontSize = portrait_subLogFontSize;
			now_editFontSize = portrait_editFontSize;
		}
	}


	/**
	 * 現在の回転方向取得
	 * @return 回転方向 横長ならtrue
	 */
	public static boolean getOrientation() {
		return isLandscape;
	}

	/**
	 * PreferenceActivityから設定を転送
	 * @param sp 情報入出力先
	 * @return リブートレベル（bit0=要画面再構成、bit1=要サービス再起動）
	 */
	public static int getFromPreferenceActivity(final SharedPreferences sp) {
		if (V) Log.v(TAG, "getFromForPreferenceActivity()");

		int rebootLevel = 0;

		final int back_verbose = verbose;
		final int back_rotateMode = rotateMode;
		final int back_now_editFontSize = now_editFontSize;
		final int back_now_mainLogFontSize = now_mainLogFontSize;
		final int back_now_subLogFontSize = now_subLogFontSize;
		final boolean back_now_horizontalMode = now_horizontalMode;
		final int back_now_subWindowMode = now_subWindowMode;
		final int back_spanChannelLogLines = spanChannelLogLines;
		final int back_spanOtherChannelLogLines = spanOtherChannelLogLines;
		final int back_mainLogBufferSize = mainLogBufferSize;
		final int back_subLogBufferSize = subLogBufferSize;
		final boolean back_ringOnAlert = ringOnAlert;
		final boolean back_vibrateOnAlert = vibrateOnAlert;
		final boolean back_allowSendHalfKana = allowSendHalfKana;
		final int back_nowColorSet = nowColorSet;

		verbose = sp_getInt(sp, "pref_sys_advanced_verbose", verbose);

		rotateMode = sp_getInt(sp, "pref_sys_view_rotatemode", rotateMode);

		now_editFontSize = sp_getInt(sp, "pref_sys_view_edit_fontsize", now_editFontSize);
		now_mainLogFontSize = sp_getInt(sp, "pref_sys_view_mainlog_fontsize", now_mainLogFontSize);
		now_subLogFontSize = sp_getInt(sp, "pref_sys_view_sublog_fontsize", now_subLogFontSize);
		now_horizontalMode = (sp_getInt(sp, "pref_sys_view_layout", (now_horizontalMode ? 1 : 0)) != 0);
		now_subWindowMode = sp_getInt(sp, "pref_sys_view_windowsize", now_subWindowMode);

		spanChannelLogLines = sp_getInt(sp, "pref_sys_advanced_log_lines_mainlog", spanChannelLogLines);
		spanOtherChannelLogLines = sp_getInt(sp, "pref_sys_advanced_log_lines_sublog", spanOtherChannelLogLines);
		mainLogBufferSize = sp_getInt(sp, "pref_sys_advanced_log_buffer_mainlog", mainLogBufferSize);
		subLogBufferSize = sp_getInt(sp, "pref_sys_advanced_log_buffer_sublog", subLogBufferSize);

		autoReconnectWaitSec = sp_getInt(sp, "pref_sys_advanced_reconnect_interval", autoReconnectWaitSec);
		checkConnectWaitSec = sp_getInt(sp, "pref_sys_advanced_keepalive_interval", checkConnectWaitSec);

		TIG_oldRTCmd = sp_getString(sp, "pref_sys_advanced_tigmode_oldrtcmd", TIG_oldRTCmd);
		twitterSiteIsMobile = sp_getBoolean(sp, "pref_sys_advanced_tigmode_twittersiteismobile", twitterSiteIsMobile);

		ringOnAlert =  sp_getBoolean(sp, "pref_sys_action_alert_ring", ringOnAlert);
		vibrateOnAlert =  sp_getBoolean(sp, "pref_sys_action_alert_vibrate", vibrateOnAlert);

		allowSendHalfKana =  sp_getBoolean(sp, "pref_sys_input_send_halfkana", allowSendHalfKana);

		nowColorSet = sp_getInt(sp, "pref_sys_view_colorset", nowColorSet);

		if (isLandscape) {
			landscape_editFontSize = now_editFontSize;
			landscape_mainLogFontSize = now_mainLogFontSize;
			landscape_subLogFontSize = now_subLogFontSize;
			landscape_horizontalMode = now_horizontalMode;
			landscape_subWindowMode = now_subWindowMode;
		} else {
			portrait_editFontSize = now_editFontSize;
			portrait_mainLogFontSize = now_mainLogFontSize;
			portrait_subLogFontSize = now_subLogFontSize;
			portrait_horizontalMode = now_horizontalMode;
			portrait_subWindowMode = now_subWindowMode;
		}

		if (back_verbose != verbose) rebootLevel |= 2;
		if (back_rotateMode != rotateMode) rebootLevel |= 1;
		if (back_now_editFontSize != now_editFontSize) rebootLevel |= 1;
		if (back_now_mainLogFontSize != now_mainLogFontSize) rebootLevel |= 1;
		if (back_now_subLogFontSize != now_subLogFontSize) rebootLevel |= 1;
		if (back_now_horizontalMode != now_horizontalMode) rebootLevel |= 1;
		if (back_now_subWindowMode != now_subWindowMode) rebootLevel |= 1;
		if (back_spanChannelLogLines != spanChannelLogLines) rebootLevel |= 2;
		if (back_spanOtherChannelLogLines != spanOtherChannelLogLines) rebootLevel |= 2;
		if (back_mainLogBufferSize != mainLogBufferSize) rebootLevel |= 2;
		if (back_subLogBufferSize != subLogBufferSize) rebootLevel |= 2;
		if (back_ringOnAlert != ringOnAlert) rebootLevel |= 2;
		if (back_vibrateOnAlert != vibrateOnAlert) rebootLevel |= 2;
		if (back_allowSendHalfKana != allowSendHalfKana) rebootLevel |= 2;
		if (back_nowColorSet != nowColorSet) rebootLevel |= 1|2|4;

		return rebootLevel;
	}
	private static int sp_getInt(final SharedPreferences sp, final String reg, final int defparam) {
		return Integer.valueOf(sp.getString(reg, Integer.toString(defparam)));
	}
	private static String sp_getString(final SharedPreferences sp, final String reg, final String defparam) {
		return sp.getString(reg, defparam);
	}
	private static boolean sp_getBoolean(final SharedPreferences sp, final String reg, final boolean defparam) {
		return sp.getBoolean(reg, defparam);
	}

	/**
	 * PreferenceActivityへ設定を転送
	 * @param sp 情報入出力先
	 */
	public static void setForPreferenceActivity(final SharedPreferences sp) {
		if (V) Log.v(TAG, "setForPreferenceActivity()");


		final SharedPreferences.Editor spe = sp.edit();

		spe_putInt(spe, "pref_sys_advanced_verbose", verbose);

		spe_putInt(spe, "pref_sys_view_rotatemode", rotateMode);

		spe_putInt(spe, "pref_sys_view_edit_fontsize", now_editFontSize);
		spe_putInt(spe, "pref_sys_view_mainlog_fontsize", now_mainLogFontSize);
		spe_putInt(spe, "pref_sys_view_sublog_fontsize", now_subLogFontSize);
		spe_putInt(spe, "pref_sys_view_layout", (now_horizontalMode ? 1 : 0));
		spe_putInt(spe, "pref_sys_view_windowsize", now_subWindowMode);

		spe_putInt(spe, "pref_sys_advanced_log_lines_mainlog", spanChannelLogLines);
		spe_putInt(spe, "pref_sys_advanced_log_lines_sublog", spanOtherChannelLogLines);
		spe_putInt(spe, "pref_sys_advanced_log_buffer_mainlog", mainLogBufferSize);
		spe_putInt(spe, "pref_sys_advanced_log_buffer_sublog", subLogBufferSize);

		spe_putInt(spe, "pref_sys_advanced_reconnect_interval", autoReconnectWaitSec);
		spe_putInt(spe, "pref_sys_advanced_keepalive_interval", checkConnectWaitSec);

		spe_putString(spe, "pref_sys_advanced_tigmode_oldrtcmd", TIG_oldRTCmd);
		spe_putBoolean(spe, "pref_sys_advanced_tigmode_twittersiteismobile", twitterSiteIsMobile);

		spe_putBoolean(spe, "pref_sys_action_alert_ring", ringOnAlert);
		spe_putBoolean(spe, "pref_sys_action_alert_vibrate", vibrateOnAlert);

		spe_putBoolean(spe, "pref_sys_input_send_halfkana", allowSendHalfKana);

		spe_putInt(spe, "pref_sys_view_colorset", nowColorSet);

		spe.commit();
	}
	private static void spe_putInt(final Editor spe, final String reg, final int param) {
		spe.putString(reg, Integer.toString(param));
	}
	private static void spe_putString(final Editor spe, final String reg, final String param) {
		spe.putString(reg, param);
	}
	private static void spe_putBoolean(final Editor spe, final String reg, final Boolean param) {
		spe.putBoolean(reg, param);
	}

	/**
	 * PreferenceActivityへ設定を転送
	 * @param sp 情報入出力先
	 */
	public static void clearForPreferenceActivity(final SharedPreferences sp) {
		if (V) Log.v(TAG, "clearForPreferenceActivity()");

		final SharedPreferences.Editor spe = sp.edit();

		spe.remove("pref_sys_advanced_verbose");

		spe.remove("pref_sys_view_rotatemode");

		spe.remove("pref_sys_view_edit_fontsize");
		spe.remove("pref_sys_view_mainlog_fontsize");
		spe.remove("pref_sys_view_sublog_fontsize");
		spe.remove("pref_sys_view_layout");
		spe.remove("pref_sys_view_windowsize");

		spe.remove("pref_sys_advanced_log_lines_mainlog");
		spe.remove("pref_sys_advanced_log_lines_sublog");
		spe.remove("pref_sys_advanced_log_buffer_mainlog");
		spe.remove("pref_sys_advanced_log_buffer_sublog");

		spe.remove("pref_sys_advanced_reconnect_interval");
		spe.remove("pref_sys_advanced_keepalive_interval");

		spe.remove("pref_sys_advanced_tigmode_oldrtcmd");
		spe.remove("pref_sys_advanced_tigmode_twittersiteismobile");

		spe.remove("pref_sys_action_alert_ring");
		spe.remove("pref_sys_action_alert_vibrate");

		spe.remove("pref_sys_input_send_halfkana");

		spe.commit();
	}
}
